Package com.google.javascript.rhino.jstype

# Class TemplateTypeMap

java.lang.Object
com.google.javascript.rhino.jstype.TemplateTypeMap

All Implemented Interfaces:
  `Serializable`

public class TemplateTypeMap extends Object implements Serializable
Manages a mapping from TemplateType to its resolved JSType. Provides utility methods for cloning/extending the map.

See Also:
  - Serialized Form

## Method Summary

Modifier and Type
Method
Description
`boolean`
`checkEquivalenceHelper(TemplateTypeMap that, com.google.javascript.rhino.jstype.EquivalenceMethod eqMethod)`
Determines if this map and the specified map have equivalent template types.
`com.google.common.collect.ImmutableList<TemplateType>`
`getTemplateKeys()`
Returns a list of all template keys.
`JSType`
`getTemplateType(TemplateType key)`
Returns the JSType value associated with the specified template key.
`TemplateType`
`getTemplateTypeKeyByName(String keyName)`
`boolean`
`hasTemplateKey(TemplateType templateKey)`
Returns true if this map contains the specified template key, false otherwise.
`boolean`
`hasTemplateType(TemplateType key)`
Returns true if there is a JSType value associated with the specified template key; false otherwise.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Method Details

### getTemplateKeys

public com.google.common.collect.ImmutableList<TemplateType> getTemplateKeys()
Returns a list of all template keys.

### hasTemplateKey

public boolean hasTemplateKey(TemplateType templateKey)
Returns true if this map contains the specified template key, false otherwise.

### hasTemplateType

public boolean hasTemplateType(TemplateType key)
Returns true if there is a JSType value associated with the specified template key; false otherwise.

### getTemplateType

public JSType getTemplateType(TemplateType key)
Returns the JSType value associated with the specified template key. If no JSType value is associated, returns UNKNOWN_TYPE.

### getTemplateTypeKeyByName

public TemplateType getTemplateTypeKeyByName(String keyName)

### checkEquivalenceHelper

public boolean checkEquivalenceHelper(TemplateTypeMap that, com.google.javascript.rhino.jstype.EquivalenceMethod eqMethod)
Determines if this map and the specified map have equivalent template types.